<?php

//
// (C) mkp, 2007
// Author: Mastushkin Kirill. Tomsk.
// E-mail: mkp@inbox.ru, mkp@tpce.tomsk.ru
// ICQ: 169035175
//
// ver 0.1.3
//

// Class methods
//
//   SetImagePath($path)
//   AddNodeImage($id, $image='')
//   AddRoot($id, $text, $image='??', $open=true)
//   AddNode($hostid, $id, $text, $image='??', $open=false)
//   SetNodeState($id, $state=true)
//   SetNodeText($id, $text)
//   show()
//   serializetree($f='')
//   unserializetree($f)
//   deletenode($nid='')
//

  if (!defined('IN_APPLICATION')) { die('hacking attempt'); }

  define("XTREE_LIB_VERSION", "0.1.3");

  class xtree
  {
    var $treeID = '';
    var $tree;
    var $nodes;
    var $counter = 0;
    var $imagepath = './images/tree';
    var $imagelist;
    var $imagewidth = 19;
    var $imageheight = 16;
    var $errors = '';
    var $unstrippedtags = '<a><img><span><b><i><u><big><br><hr><font><small>';

    // Constructor
    function xtree($treeID = "") {
      $this->treeID = "{$treeID}";
      $this->tree = array();
      $this->nodes = array();
      $this->imagelist = array();
      $this->imagelist["standartroot"]   = "_root.gif";
      $this->imagelist["standartfolder"] = "_node.gif";
      $this->imagelist["standartleaf"]   = "_leaf.gif";
      if (file_exists("{$this->imagepath}/node.php")) {
        include("{$this->imagepath}/node.php");
        $this->imagewidth = (isset($nodewidth)) ? $nodewidth : 19;
        $this->imageheight = (isset($nodeheight)) ? $nodeheight : 16;
      }
    }

    function SetImagePath($path) {
      $this->imagepath = "$path";
      $this->imagelist["standartroot"]   = "_root.gif";
      $this->imagelist["standartfolder"] = "_node.gif";
      $this->imagelist["standartleaf"]   = "_leaf.gif";
      if (file_exists($this->imagepath.'/node.php')) {
        include($this->imagepath.'/node.php');
        $this->imagewidth = (isset($nodewidth)) ? $nodewidth : 19;
        $this->imageheight = (isset($nodeheight)) ? $nodeheight : 16;
      }
    }

    function AddNodeImage($id, $image='') {
      if (!empty($id)) {
        $image = trim("{$image}");
        if (empty($image)) $image = "{$id}.gif";
        if (file_exists("{$this->imagepath}/{$image}")) {
          $this->imagelist["{$id}"] = $image;
          return true;
        } else $this->errors .= "({$this->treeID}) File [{$this->imagepath}/{$image}] does not exists\n";
      } else $this->errors .= "({$this->treeID}) Empty image ID\n";
      return false;
    }

    // Add Root
    function AddRoot($id, $text, $image='??', $open='??') {
      $id    = trim("{$id}"); 
      $text  = trim(strip_tags("{$text}", $this->unstrippedtags));
      $image = trim("{$image}");
      if (!empty($id)) {
        if (!isset($this->nodes[$id])) {
          if (!empty($text)) {
            $this->counter++;
            $this->nodes["{$id}"] = array('path'=>"['{$id}']", 'hostid'=>'', 'index'=>$this->counter, 'text'=>$text, 'image'=>$image, 'count'=>0, 'open'=>$open);
            $this->tree["{$id}"] = array();
            return true;
          } else $this->errors .= "({$this->treeID}) Empty node text [{$id}]\n";
        } else $this->errors .= "({$this->treeID}) Dublicate node ID [{$id}]\n";
      } else $this->errors .= "({$this->treeID}) Empty node ID\n";
      return false;
    }

    // Add Node
    function AddNode($hostid, $id, $text, $image='??', $open='??') {
      $hostid = trim("{$hostid}"); 
      $id     = trim("{$id}"); 
      $text   = trim(strip_tags("{$text}", $this->unstrippedtags));
      $image  = trim("{$image}");
      if (!empty($hostid)) {
        if (isset($this->nodes[$hostid])) {
          if (!empty($id)) {
            if (!isset($this->nodes[$id])) {
              if (!empty($text)) {
                $this->counter++;
                $path = $this->nodes[$hostid]['path'];
                $this->nodes[$id] = array('path'=>"{$path}['{$id}']", 'hostid'=>$hostid, 'index'=>$this->counter, 'text'=>$text, 'image'=>$image, 'count'=>0, 'open'=>$open);
                $this->nodes[$hostid]['count']++;
                $s = "\$this->tree {$path} ['{$id}'] = array();"; eval($s);
                return true;
              } else $this->errors .= "({$this->treeID}) Empty node text [{$id}]\n";
            } else $this->errors .= "({$this->treeID}) Dublicate node ID [{$id}]\n";
          } else $this->errors .= "({$this->treeID}) Empty node ID\n";
        } else $this->errors .= "({$this->treeID}) Host node [{$hostid}] does not defined\n";
      } else $this->errors .= "({$this->treeID}) Empty host node ID\n";
      return false;
    }

    // SetNodeState
    function SetNodeState($id, $state=true) {
      if (isset($this->nodes[$id])) {
        $this->nodes[$id]['open'] = $state;
      } else $this->errors .= "({$this->treeID}) Node [{$id}] does not defined\n";
    }

    // SetNodeText
    function SetNodeText($id, $text) {
      if (isset($this->nodes[$id])) {
        $text  = trim(strip_tags("{$text}", $this->unstrippedtags));
        $this->nodes[$id]['text'] = "{$text}";
      } else $this->errors .= "({$this->treeID}) Node [{$id}] does not defined\n";
    }

    // Visualization
    function show() {
      $this->showbranch($this->tree, 1); 
    }

    function showbranch($branch, $root = 0) {
      $items   = count($branch);
      $treeID  = $this->treeID;
      $iwidth  = $this->imagewidth;
      $iheight = $this->imageheight;
      $imgpth  = $this->imagepath;
      $counter = 0;

      print "<table border=0 cellspacing=\"0\" cellpadding=\"0\" style=\"table-layout: fixed;\">\n";
      if ($root) print "<col width=\"{$iwidth}px\" /><col width=*/>\n";
      else       print "<col width=\"{$iwidth}px\" /><col width=\"{$iwidth}px\" /><col width=*/>\n";
      reset($branch);
      while (list ($id, $childs) = each ($branch)) { 
        $counter++;
        $hostid = $this->nodes[$id]['hostid'];
        $index  = $this->nodes[$id]['index'];
        $count  = $this->nodes[$id]['count']; 
        $text   = $this->nodes[$id]['text']; 

        print "<tr>";

        $display = '';
        $state = '_minus';
        if (!$root) {
          if (gettype($this->nodes[$id]['open']) == 'string') $this->nodes[$id]['open'] = xTreeNodeState($treeID, $id);
          if (!$this->nodes[$id]['open']) {
            $display = 'none';
            $state = '_plus';
          }
          if ($count>0) {
            if ($items != $counter) $image = "<span onClick=\"javascript:OC('{$treeID}', '{$index}', '{$id}', '{$imgpth}', {$root});\" onMouseOver=\"this.style.cursor='hand'\"><img src=\"$imgpth/{$state}.gif\"  border=0 width=\"{$iwidth}px\" height=\"{$iheight}px\" id=\"i{$treeID}{$index}\" /></span>";
            else                    $image = "<span onClick=\"javascript:OC('{$treeID}', '{$index}', '{$id}', '{$imgpth}', {$root});\" onMouseOver=\"this.style.cursor='hand'\"><img src=\"$imgpth/{$state}2.gif\" border=0 width=\"{$iwidth}px\" height=\"{$iheight}px\" id=\"i{$treeID}{$index}\" /></span>";
            print "<td class=treenode>{$image}</td>";
          } else {
            if ($items != $counter) print "<td background=\"{$imgpth}/_cross.gif\"></td>";
            else                    print "<td background=\"{$imgpth}/_coner.gif\"></td>";
          }
        }

        // Node image
        $image  = $this->nodes[$id]['image'];
        if (!empty($image)) {
          if (!isset($this->imagelist[$image])) {
            if ($image != '??') $this->errors .= "({$this->treeID}) Undefined image [{$image}] assigned for node [{$id}]\n";
            if ($root) $img = $this->imagelist['standartroot'];
            else
              if ($count>0) $img = $this->imagelist['standartfolder'];
              else          $img = $this->imagelist['standartleaf'];
          } else $img = $this->imagelist[$image];
          print "<td class=\"treenode\"><img width=\"{$iwidth}px\" height=\"{$iheight}px\" src=\"{$imgpth}/{$img}\" id=\"f{$treeID}{$index}\" border=0 align=absMiddle /></td><td class=\"treenodetext\"><nobr>{$text}</nobr></td>";
        } else {
          print "<td class=treenodetext height={$iheight}px colspan=2><nobr>{$text}</nobr></td>";
        }

        print "</tr>\n";

        if ($count>0) {
          $image = $items==$counter?'_clear':'_vline';
          print "<tr id=\"t{$treeID}{$index}\" style=\"display:{$display};\">";
          if (!$root) print "<td background=\"{$imgpth}/{$image}.gif\"></td>";
          print "<td class=treenode colspan=2>\n"; $this->showbranch($childs); print "</td></tr>\n";
        }
      }
      print "</table>\n";
    }

    function serializetree($f='') {
      if (empty($f)) $f = "./{$this->treeID}_.tree";
      if ($fh = fopen($f, 'w')) {
        fputs($fh, serialize($this));
        fclose($fh);
      }
    }

    function unserializetree($f) {
      if (file_exists("{$f}")) {
        if ($fh = fopen($f, 'r')) {
          $s = fgets($fh);
          fclose($fh);
          if ($t = unserialize($s)) {
            $this->treeID         = $t->treeID;
            $this->tree           = $t->tree;
            $this->nodes          = $t->nodes;
            $this->counter        = $t->counter;
            $this->imagepath      = $t->imagepath;
            $this->imagelist      = $t->imagelist;
            $this->imagewidth     = $t->imagewidth;
            $this->imageheight    = $t->imageheight;
            $this->errors         = $t->errors;
            $this->unstrippedtags = $t->unstrippedtags;
          } else $this->errors .= "({$this->treeID}) Can't unserialize\n";
        } else $this->errors .= "({$this->treeID}) Can't open file [{$f}] \n";
      } else $this->errors .= "({$this->treeID}) File [{$f}] not found\n";
    }

    function deletenode($nid='') {
      $nid = trim("{$nid}");
      if (isset($this->nodes[$nid])) {
        $p = $this->nodes[$nid]['path'];
        $s = "\$this->deletebranch(\$this->tree{$p}); unset(\$this->tree{$p});"; eval($s);
        unset($this->nodes[$nid]);
      } else $this->errors .= "({$this->treeID}) Node [{$nid}] does not defined\n";
    }
    function deletebranch($b) {
      while(list($i, $c) = each($b)) {
        unset($this->nodes[$i]);
        $this->deletebranch($c);
      }
    }

  } // class xtree

  function xTreeNodeState($treeID, $nodeID) {
    if (isset($_COOKIE["tree_{$treeID}_state"])) {
      $cookie = $_COOKIE["tree_{$treeID}_state"];
      if (!(strpos($cookie, "*{$nodeID}*") === false)) return true;
    }
    return false;
  }

?>